moCmd = {};

function moCmd.emptyCmd()
end;

function moCmd.openCloseSlot(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	moSetGetOverlays.slot[args.cmdTable.ownTable.whichSlot].isOpen = not moSetGetOverlays.slot[args.cmdTable.ownTable.whichSlot].isOpen;
end;

function moCmd.openClosePda(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	moSetGetOverlays.pda[args.cmdTable.ownTable.whichPda].isOpen = not moSetGetOverlays.pda[args.cmdTable.ownTable.whichPda].isOpen;
end;

function moCmd.closeAllPdas()
	moDraw.pda:setClose();	
end;

function moCmd.switchViewModusPda(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	moDraw.pda:setViewModus(args.cmdTable.ownTable.whichPda);		
end;

function moCmd.closeAllSlots()
	moDraw.slot:setClose();	
end;

function moCmd.handToolsSwitch(args)
	if args == nil or type(args) ~= "table" then return;end;		
	if moGeneralSettings.other.handToolsSwitch then				
		moGeneralSettings.other.handToolsSwitch = false;
		if g_currentMission.player:hasHandtoolEquipped() then 
			g_currentMission:showBlinkingWarning("Hand Tools Switch Off ! HAND NOT EMPTY !", 3000);				
		else
			g_currentMission:showBlinkingWarning("Hand Tools Switch Off", 2000);
		end;
	else 
		moGeneralSettings.other.handToolsSwitch = true;				
		g_currentMission:showBlinkingWarning("Hand Tools On", 2000);
	end;	
end;

function moCmd.openCloseAutoDrive(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.autoDrive == nil then g_currentMission:showBlinkingWarning("AutoDrive Mod Not Found", 3500);return;end;
	if MultiOverlayV4.otherMods.autoDrive.ADInputManager ~= nil and g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.trainSystem == nil then
		MultiOverlayV4.otherMods.autoDrive.ADInputManager.onActionCall(g_currentMission.controlledVehicle, "ADToggleHud");						
	end;
end;

function moCmd.strongFarmer(args, reset, noShowWarning)
	if reset ~= nil and reset then
		if MultiOverlayV4.otherMods.strongFarmer == nil then return;end;
		moGeneralSettings.other.strongFarmer.isOn = true;
		Player.MAX_PICKABLE_OBJECT_MASS = moGeneralSettings.other.strongFarmer.maxMass;
		Player.MAX_PICKABLE_OBJECT_DISTANCE = moGeneralSettings.other.strongFarmer.maxDistance;
	end;
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.strongFarmer == nil then 
		if noShowWarning == nil or (noShowWarning ~= nil and not noShowWarning) then
			g_currentMission:showBlinkingWarning("StrongFarmer Mod Not Found", 3500);
		end;
		return;		
	end;
	if moGeneralSettings.other.strongFarmer.isOn then 
		moGeneralSettings.other.strongFarmer.isOn = false;
		Player.MAX_PICKABLE_OBJECT_MASS = 0.2;
		Player.MAX_PICKABLE_OBJECT_DISTANCE = 3;
		if noShowWarning == nil or (noShowWarning ~= nil and not noShowWarning) then
			g_currentMission:showBlinkingWarning("Strong Farmer Off", 2000);
		end;
	else
		moGeneralSettings.other.strongFarmer.isOn = true;
		Player.MAX_PICKABLE_OBJECT_MASS = moGeneralSettings.other.strongFarmer.maxMass;
		Player.MAX_PICKABLE_OBJECT_DISTANCE = moGeneralSettings.other.strongFarmer.maxDistance;
		if noShowWarning == nil or (noShowWarning ~= nil and not noShowWarning) then
			g_currentMission:showBlinkingWarning("Strong Farmer On", 2000);
		end;
	end;
end;
	



