moSetGetCmd = {};
source(MultiOverlayV4.modDir.."scripte/cmd/moCmd.lua");
source(MultiOverlayV4.modDir.."scripte/cmd/outputActionOpenCloseCmd.lua");

function moSetGetCmd:generateCmd(args)
	if MultiOverlayV4.cmd == nil then MultiOverlayV4.cmd = {};end;
	if MultiOverlayV4.cmdSetting == nil then MultiOverlayV4.cmdSetting = {selectCmd={}};end;
	if MultiOverlayV4.cmdByGroupName == nil then MultiOverlayV4.cmdByGroupName = {};end;
	if MultiOverlayV4.cmdByModName == nil then MultiOverlayV4.cmdByModName = {};end;
	if args == nil or type(args) ~= "table" or args.modName == nil or args.cmdName == nil then return false, "missing args table or incorrect";end;
	if args.typ == nil or type(args) ~= "table" then return false, "missing args typ= {action_ } or {output_} or {outputAction_} or {actionOutput_}";end;
	if string.find(args.cmdName, " ") then return false, "cmdName must not have any spaces";end;
	if string.find(args.groupName, " ") then return false, "groupName must not have any spaces";end;
	if not string.find(args.cmdName, "_", string.len(args.cmdName)-1) then return false, "cmdName must have _ on end";end;
	local modName = string.gsub(args.modName, " ", "");	
	if MultiOverlayV4.cmd[modName.. "_cmd_".. args.cmdName] ~= nil then return false, "cmd name already exists";end;
	if args.actionCallback == nil or type(args.actionCallback) ~= "function" then return false, "actionCallback not a function or incorrect";end;
	MultiOverlayV4.cmd[modName.. "_cmd_".. args.cmdName] = {};
	local cmdTable = MultiOverlayV4.cmd[modName.. "_cmd_".. args.cmdName];
	cmdTable.regName = modName.. "_cmd_".. args.cmdName;
	cmdTable.cmdName = args.cmdName;
	cmdTable.modName = modName;
	cmdTable.realModName = args.modName;
	cmdTable.actionCallback = args.actionCallback;
	cmdTable.freeCmd = args.freeCmd; --default true 
	cmdTable.mouseClickAccepts = args.mouseClickAccepts; --default all, a table {true,true,false} left,middle,right
	if cmdTable.mouseClickAccepts == nil or type(cmdTable.mouseClickAccepts) ~= "table" or #cmdTable.mouseClickAccepts < 3 then cmdTable.mouseClickAccepts = {true,true,true};end;
	cmdTable.displayName = args.displayName or "Unknown";
	cmdTable.groupName = args.groupName or "Unknown";	
	cmdTable.infoTxt = args.infoTxt;
	cmdTable.helpTxt = args.helpTxt;
	cmdTable.ownTable = args.ownTable;
	cmdTable.object = args.object;	
	cmdTable.typ = args.typ;
	function comp(w1,w2)		
		if w1 < w2 then
			return true;
		end;				
	end;			
	if MultiOverlayV4.cmdByGroupName[cmdTable.groupName] == nil then
		MultiOverlayV4.cmdByGroupName[cmdTable.groupName] = {};		
	end;	
	MultiOverlayV4.cmdByGroupName[cmdTable.groupName][#MultiOverlayV4.cmdByGroupName[cmdTable.groupName]+1] ={cmd = modName.. "_cmd_".. args.cmdName};
	table.sort(MultiOverlayV4.cmdByGroupName, comp);	
	if MultiOverlayV4.cmdByModName[modName] == nil then
		MultiOverlayV4.cmdByModName[modName] = {};		
	end;
	MultiOverlayV4.cmdByModName[modName][#MultiOverlayV4.cmdByModName[modName]+1] = {cmd = modName.. "_cmd_".. args.cmdName};
	table.sort(MultiOverlayV4.cmdByModName, comp);
	if args.setCmdSlotCallback ~= nil and type(args.setCmdSlotCallback) == "function" then
		cmdTable.setCmdSlotCallback = args.setCmdSlotCallback;
	end;
	if args.delCmdSlotCallback ~= nil and type(args.delCmdSlotCallback) == "function" then
		cmdTable.delCmdSlotCallback = args.delCmdSlotCallback;
	end;
	return true;
end;

function moSetGetCmd:deleteCmd(args)
	if args == nil or type(args) ~= "table" then return false, "missing args table";end;
	if args.modName == nil or args.cmdName == nil then return false, "missing args modName= and or cmdName=";end;
	local modName = string.gsub(args.modName, " ", "");
	if MultiOverlayV4.cmd[modName.. "_cmd_".. args.cmdName] == nil then return false, "cmd not found";end;
	MultiOverlayV4.cmd[modName.. "_cmd_".. args.cmdName] = nil;
	for a=1, #MultiOverlayV4.cmdByModName[modName] do
		if MultiOverlayV4.cmdByModName[modName][a].cmd == modName.. "_cmd_".. args.cmdName then MultiOverlayV4.cmdByModName[modName][a].cmd = nil;break;end;
	end;
	if #MultiOverlayV4.cmdByModName[modName] == 0 then MultiOverlayV4.cmdByModName[modName] = nil;end;
	local foundGroup = false;
	for groupName, index in pairs (MultiOverlayV4.cmdByGroupName) do
		for a=1, #MultiOverlayV4.cmdByGroupName[groupName] do
			if MultiOverlayV4.cmdByGroupName[groupName][a].cmd == modName.. "_cmd_".. args.cmdName then MultiOverlayV4.cmdByGroupName[groupName][a].cmd = nil;foundGroup=true;break;end;
		end;
		if foundGroup and #MultiOverlayV4.cmdByGroupName[groupName] == 0 then MultiOverlayV4.cmdByGroupName[groupName]=nil;break;end;
		if foundGroup then break;end;
	end;
	return true;
end;

function moSetGetCmd:deleteAllPdaCmds()
	local pdas = moSetGetPda:getPdas();
	if #pdas > 0 then
		for pda=1, #pdas do				
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="outputAction_".. tostring(pdas[pda])} );
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_".. tostring(pdas[pda])} );
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_switchViewModus_".. tostring(pdas[pda])} );
		end;
	end;		
end;

function moSetGetCmd:deleteAllSlotCmds()
	local slots = moSetGetSlot:getSlots();
	if #slots > 0 then
		for slot=1, #slots do				
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="outputAction_".. tostring(slots[slot])} );
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_".. tostring(slots[slot])} );			
		end;
	end;
end;

function moSetGetCmd:setOpenCloseSlotCmd(whichSlot)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "outputAction_"..whichSlot;
			groupName = "Open/Close";			
			displayName = "Slot ".. moSetGetOverlays.slot[whichSlot].name;			
			infoTxt = "Open/Close this Slot";
			typ = {"outputAction_"};
			mouseClickAccepts = {true,false,false}; 
			ownTable = {whichSlot=whichSlot};
			actionCallback = outputActionOpenCloseCmd.giveOutputTable;			
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_"..whichSlot;
			groupName = "Open/Close";			
			displayName = "Slot ".. moSetGetOverlays.slot[whichSlot].name;			
			infoTxt = "Open/Close this Slot";
			typ = {"action_"};
			ownTable = {whichSlot=whichSlot};
			actionCallback = moCmd.openCloseSlot;			
		}
	)
end;

function moSetGetCmd:setOpenClosePdaCmd(whichPda) --new +switchViewModus
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "outputAction_"..whichPda;
			groupName = "Open/Close";			
			displayName = "Pda ".. moSetGetOverlays.pda[whichPda].name;			
			infoTxt = "Open/Close this Pda";
			typ = {"outputAction_"};
			mouseClickAccepts = {true,false,false};
			ownTable = {whichPda=whichPda};
			actionCallback = outputActionOpenCloseCmd.giveOutputTable;			
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_"..whichPda;
			groupName = "Open/Close";			
			displayName = "Pda ".. moSetGetOverlays.pda[whichPda].name;			
			infoTxt = "Open/Close this Pda";
			typ = {"action_"};			
			ownTable = {whichPda=whichPda};
			actionCallback = moCmd.openClosePda;			
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_switchViewModus_"..whichPda;
			groupName = "Pda-SwitchModus";			
			displayName = "Pda ".. moSetGetOverlays.pda[whichPda].name;			
			infoTxt = "Switch ViewModus this Pda";
			typ = {"action_"};			
			ownTable = {whichPda=whichPda};
			actionCallback = moCmd.switchViewModusPda;			
		}
	)
end;

function moSetGetCmd:setMohDefaultCmds()
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "outputAction_closeAllSlots_";
			groupName = "Close";			
			displayName = "Close all Slots";
			infoTxt = "Close all MultiOverlay Slots";
			typ = {"outputAction_"};
			ownTable = {closeAll="slots"};
			mouseClickAccepts = {true,false,false};
			actionCallback = outputActionOpenCloseCmd.giveOutputTable;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_closeAllSlots_";
			groupName = "Close";			
			displayName = "Close all Slots";
			infoTxt = "Close all MultiOverlay Slots";
			typ = {"action_"};			
			actionCallback = moCmd.closeAllSlots;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "outputAction_closeAllPdas_";
			groupName = "Close";			
			displayName = "Close all Pdas";
			infoTxt = "Close all MultiOverlay Pdas";
			typ = {"outputAction_"};
			ownTable = {closeAll="pdas"};
			mouseClickAccepts = {true,false,false};
			actionCallback = outputActionOpenCloseCmd.giveOutputTable;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_closeAllPdas_";
			groupName = "Close";			
			displayName = "Close all Pdas";
			infoTxt = "Close all MultiOverlay Pdas";
			typ = {"action_"};			
			actionCallback = moCmd.closeAllPdas;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_handToolsSwitch_";
			groupName = "OnOff-OtherMods";			
			displayName = "Hand Tools Switch On/Off";
			infoTxt = "Verhindert das Hand Tools Scollen\nChainsaw etc.";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.handToolsSwitch;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_autoDrive_";
			groupName = "OnOff-OtherMods";			
			displayName = "AutoDrive Hud On/Off";
			infoTxt = "Öffnet und schliesst das AutoDrive Hud Fenster. (Open/Close AutoDrive Hud) *needs AutoDrive Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.openCloseAutoDrive;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_strongFarmer_";
			groupName = "OnOff-OtherMods";			
			displayName = "Strong Farmer On/Off";
			infoTxt = "Starker Bauer On/Off. *needs StrongFarmer Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.strongFarmer;
		}
	)
end;

function moSetGetCmd:getCmdTable()
	return MultiOverlayV4.cmd;
end;

function moSetGetCmd:getGroupCmdTable(group)
	return MultiOverlayV4.cmdByGroupName[group];
end;

function moSetGetCmd:getModCmdTable(modName)
	local modName = string.gsub(modName, " ", "");
	return MultiOverlayV4.cmdByModName[modName];
end;

-------------mod setGetCmdFunction-------------
g_currentMission.multiOverlayV4.cmdFunction={
	generateCmd = function(args)return moSetGetCmd:generateCmd(args);end;
	deleteCmd = function(args)return moSetGetCmd:deleteCmd(args);end;
	getCmdTable = function()return moSetGetCmd:getCmdTable();end;
	getGroupCmdTable = function(group)return moSetGetCmd:getGroupCmdTable(group);end;
	getModCmdTable = function(modName)return moSetGetCmd:getModCmdTable(modName);end;
};
-------------mod setGetCmdFunction-------------