moSetGet = {};
local test = true;
function moSetGet:setMiniMapState()
	if not moGeneralSettings.miniMapAutoState.on then return;end;	
	if moGeneralSettings.miniMapAutoState.viewIcons then moDraw.miniMapAutoState:setOpen();end;
	local inGameMapState = g_currentMission.hl.getIngameMapState();
	if moGeneralSettings.miniMapAutoState.state[inGameMapState] then return;end;	
	local setNew = false;
	function setState(state)
		g_currentMission.hud.ingameMap.layout:deactivate();
		--if state == 5 then --later set fullScreen for more details			
			--g_currentMission.hud.ingameMap.isFullscreen = true;
			--g_currentMission.hud.ingameMap.layout = g_currentMission.hud.ingameMap.fullScreenLayout;
		--else
			g_currentMission.hud.ingameMap.state = state;
			g_currentMission.hud.ingameMap.layout = g_currentMission.hud.ingameMap.layouts[state];
			g_currentMission.hud.ingameMap.layout:activate();
		--end;		
		g_inputBinding:setActionEventTextVisibility(g_currentMission.hud.ingameMap.toggleMapSizeEventId, g_currentMission.hud.ingameMap.layout:getShowsToggleActionText())
		g_gameSettings:setValue("ingameMapState", state, true)
		--if state ~= 5 then g_gameSettings:setValue("ingameMapState", state, true);end;		
	end;	
	if inGameMapState <= 4 then			
		if moGeneralSettings.miniMapAutoState.state[inGameMapState] ~= nil and not moGeneralSettings.miniMapAutoState.state[inGameMapState] then 		
			for a=inGameMapState, 4 do
				if moGeneralSettings.miniMapAutoState.state[a] ~= nil and moGeneralSettings.miniMapAutoState.state[a] then					
					setState(a)
					setNew = true;
					break;					
				end;
			end;
		end;
		if not setNew then setState(1);end;
	end;	
	return;	
end;

function moSetGet:errorSetMiniMapAutoState()
	return not moGeneralSettings.miniMapAutoState.state[1] and not moGeneralSettings.miniMapAutoState.state[2] and not moGeneralSettings.miniMapAutoState.state[3];
end;

function moSetGet:setMiniMapAutoState(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.whatClick == "miniMapAutoStateIcon" then
		local state = Utils.getNoNil(tonumber(args.whereClick), 0);
		if state == 0 then return;end;
		moGeneralSettings.miniMapAutoState.state[state] = not moGeneralSettings.miniMapAutoState.state[state];
		if moSetGet:errorSetMiniMapAutoState() then moGeneralSettings.miniMapAutoState.state[1] = true;end;
	end;
end;

function moSetGet:setWtmState(typ, state, all)
	if typ == "ShowWeather" or all then
		g_currentMission.hud.gameInfoDisplay:setWeatherVisible(state);
	end;
	if typ == "ShowTemperature" or all then
		g_currentMission.hud.gameInfoDisplay:setTemperatureVisible(state);
	end;
	if typ == "ShowIngameDate" or all then
		g_currentMission.hud.gameInfoDisplay:setDateVisible(state);
	end;
	if typ == "ShowIngameTime" or all then
		g_currentMission.hud.gameInfoDisplay:setTimeVisible(state);
	end;
	if typ == "ShowMoney" or all then
		g_currentMission.hud.gameInfoDisplay:setMoneyVisible(state);
	end;
end;

function moSetGet:refreshWtmState()
	g_currentMission.hud.gameInfoDisplay:setWeatherVisible(moGeneralSettings.wtm.weather.show);
	g_currentMission.hud.gameInfoDisplay:setTemperatureVisible(moGeneralSettings.wtm.temperature.show);
	g_currentMission.hud.gameInfoDisplay:setDateVisible(moGeneralSettings.wtm.ingamedate.show);
	g_currentMission.hud.gameInfoDisplay:setTimeVisible(moGeneralSettings.wtm.ingametime.show);
	g_currentMission.hud.gameInfoDisplay:setMoneyVisible(moGeneralSettings.wtm.money.show);
end;

function moSetGet:loadDefaultWtmState()
	moGeneralSettings.wtm.weather.show = g_currentMission.hud.gameInfoDisplay.showWeather;
	moGeneralSettings.wtm.temperature.show = g_currentMission.hud.gameInfoDisplay.showTemperature;
	moGeneralSettings.wtm.ingamedate.show = g_currentMission.hud.gameInfoDisplay.showDate;
	moGeneralSettings.wtm.ingametime.show = g_currentMission.hud.gameInfoDisplay.showTime;
	moGeneralSettings.wtm.money.show = g_currentMission.hud.gameInfoDisplay.showMoney;
end;

function moSetGet:getWtmState(typ)
	if g_currentMission.hud == nil then
		if typ == "ShowWeather" then
			return moGeneralSettings.wtm.weather.show;
		elseif typ == "ShowTemperature" then
			return moGeneralSettings.wtm.temperature.show;
		elseif typ == "ShowIngameDate" then
			return moGeneralSettings.wtm.ingamedate.show;
		elseif typ == "ShowIngameTime" then
			return moGeneralSettings.wtm.ingametime.show;
		elseif typ == "ShowMoney" then
			return moGeneralSettings.wtm.money.show;
		end;
	else
		if typ == "ShowWeather" then
			return g_currentMission.hud.gameInfoDisplay.showWeather;
		elseif typ == "ShowTemperature" then
			return g_currentMission.hud.gameInfoDisplay.showTemperature;
		elseif typ == "ShowIngameDate" then
			return g_currentMission.hud.gameInfoDisplay.showDate;
		elseif typ == "ShowIngameTime" then
			return g_currentMission.hud.gameInfoDisplay.showTime;
		elseif typ == "ShowMoney" then
			return g_currentMission.hud.gameInfoDisplay.showMoney;
		end;
	end;
	return true;
end;

function moSetGet:getIsRaining(rainScale)
	return rainScale > 0.05;
end

function moSetGet:getRainScale(state)
	return g_currentMission.environment.weather:getRainFallScale(state);
end;

function moSetGet:getSnowScale()
	local rainScale = moSetGet:getRainScale(true);
	local snowScale = moSetGet:getRainScale(false) - rainFallScale;
	return snowScale;
end;

function moSetGet:getCloudData()
	local cloudData = g_currentMission.environment.weather.cloudUpdater:getCurrentValues();
	return cloudData.type;
end;

function moSetGet:getFogData()
	return g_currentMission.environment.weather.fogUpdater:getCurrentValues();
end;

function moSetGet:getWeatherTypeAtTime(hour) -- 12 or 24
	local env = g_currentMission.environment;
	local dayTime = env.weather.forecast.owner.owner.dayTime + hour * 60 * 60 * 1000;
	local day = env.weather.forecast.owner.owner.currentMonotonicDay;	
	if #env.weather.forecastItems == 0 then
		return WeatherType.SUN;
	end;
	local instance = env.weather.forecastItems[1];
	for _, object in ipairs(env.weather.forecastItems) do
		if object.startDay < day or object.startDay == day and object.startDayTime < dayTime then
			instance = object;
		else
			break;
		end;
	end;
	local object = env.weather:getWeatherObjectByIndex(instance.season, instance.objectIndex);
	return object.weatherType.index;
end;

function moSetGet:getHourlyForecast(hours) -- 1-24
	local isWeatherStation = g_currentMission.placeableSystem:getHasWeatherStation(g_currentMission:getFarmId());
	local env = g_currentMission.environment;
	local forecastWeather = {};
	for w=1, hours do
		local forecastInfo = env.weather.forecast:getHourlyForecast(w);
		if forecastInfo ~= nil then
			local timeHours = math.floor(forecastInfo.time / 3600000 + 0.0001);			
			forecastInfo.formatTime = string.format("%02d:00", timeHours);
			local period = g_currentMission.environment:getPeriodFromDay(forecastInfo.day);
			local dayInPeriod = g_currentMission.environment:getDayInPeriodFromDay(forecastInfo.day);
			forecastInfo.dayPeriod = g_i18n:formatDayInPeriod(dayInPeriod, period, false);
			table.insert(forecastWeather, forecastInfo);
		end;
	end;
	return forecastWeather;
end;

function moSetGet:playerHandTool()
	oldPlayerStateCycleHandtool = PlayerStateCycleHandtool.isAvailable;
	PlayerStateCycleHandtool.isAvailable = function (self)
		local isOkay, result = pcall(oldPlayerStateCycleHandtool, self);
		if isOkay and self ~= nil then
			if not moGeneralSettings.other.handToolsSwitch then return false;end;			
			return result;
		end;
	end;	
end;