moAnimals = {};
source(MultiOverlayV4.modDir.."scripte/module/animals/moAnimalsConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/animals/moAnimalsOutput.lua");

function moAnimals:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="animals"} ) then
		if moAnimalsConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateAnimals"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moAnimalsConfig.values.updateTimer, name="updateAnimals", repeatable=1, ms=moAnimalsConfig.values.msec, action=moAnimals.load} ); 
		else
			moAnimals:load();
		end;
	end;
end;

function moAnimals.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete obbject etc. delete your old cmds!	
	if moAnimalsConfig.values == nil then moAnimalsConfig:defaultValues();end;
	if update then moAnimalsConfig:deleteCmd();end;
	moAnimals:loadAllAnimals(true);	
end;

function moAnimals.load() --updateTimer Callback	
	moAnimals:loadAllAnimals();	
end;

function moAnimals:loadAllAnimals(generateCmd)	
	local playerFarmId = g_currentMission.player.farmId;	
	if moModule.animals ~= nil and #moModule.animals > 0 then
		local deleteObject = {};
		for index=1, #moModule.animals do			
			if moModule.animals[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.animals[index].object);
				if isObject then
					local animal = moModule.animals[index].object;
					local isViewOutput = (generateCmd ~= nil and generateCmd) or animal.ownerFarmId == playerFarmId or animal.ownerFarmId == 0;
					if isViewOutput then						
						if animal.mohTable == nil then
							animal.mohTable = {general={},production={},output={},input={}};						
						else
							animal.mohTable.general={};animal.mohTable.production={};animal.mohTable.output={};animal.mohTable.input={};
						end;
						if animal.mohTable.viewOutput == nil then animal.mohTable.viewOutput = false;end;	
						if animal.mohTable.viewInput == nil then animal.mohTable.viewInput = false;end;
						if animal.mohTable.viewMoreInfo == nil then animal.mohTable.viewMoreInfo = false;end;
						if animal.mohTable.viewProductionInfo == nil then animal.mohTable.viewProductionInfo = false;end;
						---general output---
						animal.mohTable.general[#animal.mohTable.general+1] = {};
						local isLineTableGeneral = animal.mohTable.general[#animal.mohTable.general];
						if animal.mohDisplayName ~= nil then 
							isLineTableGeneral.objectName = animal.mohTable.mohDisplayName;
						else
							isLineTableGeneral.objectName = animal.mohTable.name;
						end;
						isLineTableGeneral.age = animal.age;
						isLineTableGeneral.isHorse = animal.spec_husbandryAnimals.animalTypeIndex == AnimalType.HORSE;
						isLineTableGeneral.numAnimals = Utils.getNoNil(animal.spec_husbandryAnimals:getNumOfAnimals(), 0);						
						isLineTableGeneral.productivityName = g_i18n:getText("statistic_productivity");
						isLineTableGeneral.productivity = Utils.getNoNil(animal:getGlobalProductionFactor(), 0)*100;
						if isLineTableGeneral.productivity == 0 then
							isLineTableGeneral.productivityColor = 7;
						else
							isLineTableGeneral.productivityColor = g_currentMission.hl.getProzentColor(Utils.getNoNil(isLineTableGeneral.productivity, 0), true);
							if isLineTableGeneral.productivityColor == 1 then isLineTableGeneral.productivityColor = 2;end;
						end;
						isLineTableGeneral.costsPerActiveMonth = 0;
						isLineTableGeneral.ownedFarmId = animal.ownerFarmId;
						isLineTableGeneral.price = Utils.getNoNil(animal.price, 0);
						---general output---
						
						local isFillLevelInformation = false;
						---output---											
						function setOutput(fillLevelInformationOutput)
							isFillLevelInformation = true;							
							animal.mohTable.output[#animal.mohTable.output+1] = {};	
							local isLineTableOutput = animal.mohTable.output[#animal.mohTable.output];
							isLineTableOutput.groupName = fillLevelInformationOutput.title;
							isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationOutput.fillLevel, 0));
							isLineTableOutput.ratio = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationOutput.ratio, 0));
							if fillLevelInformationOutput.foodGroupFillTypes ~= nil then
								for a=1,  #fillLevelInformationOutput.foodGroupFillTypes do
									if fillLevelInformationOutput.foodGroupFillTypes[a] ~= nil then
										local fillType = moFillTypes.values.fillTypes[fillLevelInformationOutput.foodGroupFillTypes[a]];
										if isLineTableOutput.fillTypeNames ~= nil then isLineTableOutput.fillTypeNames = isLineTableOutput.fillTypeNames.. "-";else isLineTableOutput.fillTypeNames="";end;
										if fillType ~= nil then
											isLineTableOutput.fillTypeNames = isLineTableOutput.fillTypeNames.. fillType.name;
										else
											isLineTableOutput.fillTypeNames = isLineTableOutput.fillTypeNames.. moLanguageXml:getTxt("unknown", nil, "Unknown");
										end;
									end;
								end;
							end;
						end;
						---output---
						---input---											
						function setInput(fillLevelInformationInput)
							isFillLevelInformation = true;
							animal.mohTable.input[#animal.mohTable.input+1] = {};	
							local isLineTableInput = animal.mohTable.input[#animal.mohTable.input];
							isLineTableInput.groupName = fillLevelInformationInput.title;
							isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationInput.fillLevel, 0));
							isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationInput.capacity, 0));
							isLineTableInput.ratio = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationInput.ratio, 0));							
							if fillLevelInformationInput.foodGroupFillTypes ~= nil then
								for a=1,  #fillLevelInformationInput.foodGroupFillTypes do
									if fillLevelInformationInput.foodGroupFillTypes[a] ~= nil then
										local fillType = moFillTypes.values.fillTypes[fillLevelInformationInput.foodGroupFillTypes[a]];
										if isLineTableInput.fillTypeNames ~= nil then isLineTableInput.fillTypeNames = isLineTableInput.fillTypeNames.. "-";else isLineTableInput.fillTypeNames="";end;
										if fillType ~= nil then
											isLineTableInput.fillTypeNames = isLineTableInput.fillTypeNames.. fillType.name;
										else
											isLineTableInput.fillTypeNames = isLineTableInput.fillTypeNames.. moLanguageXml:getTxt("unknown", nil, "Unknown");
										end;
									end;
								end;
							end;
						end;																	
						---input---
						local fillLevelInformation = moModuleSetGet:getAnimalFillLevelInformation(animal);
						if fillLevelInformation ~= nil then
							if fillLevelInformation.output ~= nil and #fillLevelInformation.output > 0 then
								for o=1, #fillLevelInformation.output do
									if fillLevelInformation.output[o] ~= nil then setOutput(fillLevelInformation.output[o]);end;
								end;
							end;
							if fillLevelInformation.input ~= nil and #fillLevelInformation.input > 0 then
								for i=1, #fillLevelInformation.input do
									if fillLevelInformation.input[i] ~= nil then setInput(fillLevelInformation.input[i]);end;
								end;
							end;
						end;						
						if generateCmd ~= nil and generateCmd then moAnimalsConfig:generateCmd(animal);end;
					end;
				else
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.animals, index);
			end;
			moAnimalsConfig:deleteCmd(true);			
		end;
	end;
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moAnimals.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moAnimals.update } );