moAnimalsOutput = {};

function moAnimalsOutput:load(cmdTable, slotTable)
	local playerFarmId = g_currentMission.player.farmId;
	local cmdRegName = cmdTable.regName;
	local cmdObject = cmdTable.object;	
	local lineTable = {line={}};	
	for o=1, #cmdObject do
		if cmdObject[o] ~= nil and moModuleObjects:isObject(cmdObject[o]) then
			---check edit object name---
			local displayName = cmdObject[o]:getName();
			if displayName ~= nil and tostring(displayName) ~= tostring(cmdObject[o].mohTable.name) then 
				moAnimalsConfig:refreshCmdDisplayName(cmdRegName, displayName);
				cmdObject[o].mohTable.name = tostring(displayName);				
			end;
			---check edit object name---			
			-------------------------------general-------------------------------
			---objectName---
			local stopInOutput = false;
			local viewMoreInfo = cmdObject[o].mohTable.viewMoreInfo;			
			local viewProductionInfo = cmdObject[o].mohTable.viewProductionInfo;
			local animalGeneral = cmdObject[o].mohTable.general[1];
			local isOwned = playerFarmId == animalGeneral.ownedFarmId and playerFarmId ~= 0; 
			local canBuy = animalGeneral.ownedFarmId == 0;
			local iconColor = "darkGray";
			local buttonName = "buttonDown";
			lineTable.line[#lineTable.line+1] = {};
			local isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txtOutputTitle";
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = tostring(animalGeneral.objectName);		
			isLineTable.txt[1].callback = moAnimalsOutput.clickAnimal;
			isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};
			local objectId = cmdObject[o].nodeId or cmdObject[o].rootNode;		
			local oX,oY,oZ = getWorldTranslation(objectId);
			if oX ~= nil and oY ~= nil and oZ ~= nil then
				local x,y,z = g_currentMission.hl.getPlayerPos();
				if x ~= nil and y ~= nil and z ~= nil then
					local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, 10);
					if nearObject then isLineTable.txt[1].txt = ">>".. isLineTable.txt[1].txt.. "<<";end;
				end;
			end;		
			isLineTable.txt[1].alignment = 2;
			if slotTable ~= nil and slotTable.help.outputOn then
				isLineTable.txt[1].icon = {before={},after={}};
				isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moAnimalsOutput.clickAnimalsHelpTxt}};
			end;
			if g_currentMission.hl.isMouseCursor and isOwned then
				iconColor = "darkGray";
				if viewMoreInfo then iconColor = "green";end;
				if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
				isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="moreInfo", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moAnimalsOutput.clickViewMoreInfo}, ownTable={cmdObject[o].rootNode}, infoTxt="More Info"};
			end;
			---objectName---
			---numAnimals---
			local numAnimalsTxt = ""
			if animalGeneral.numAnimals ~= nil and animalGeneral.numAnimals <= 0 then
				numAnimalsTxt = tostring(g_i18n:getText("ui_noAnimals"));
			else
				numAnimalsTxt = tostring(g_i18n:getText("ui_statisticViewAnimals"));
			end;
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].slotColor = "txt";
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = numAnimalsTxt;			
			if animalGeneral.numAnimals ~= nil and animalGeneral.numAnimals > 0 then
				isLineTable.txt[1].width = 90;
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = true;
				isLineTable.txt[2].txt = tostring(animalGeneral.numAnimals);
				isLineTable.txt[2].width = 10;
				isLineTable.txt[2].alignment = 3;
			end;
			---numAnimals---
			if isOwned and viewMoreInfo then				
				---age---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_age"));
				isLineTable.txt[1].width = 70;
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = true;			
				if animalGeneral.age > 1 or animalGeneral.age == 0 then 
					isLineTable.txt[2].txt = tostring(animalGeneral.age).. " ".. tostring(g_i18n:getText("ui_days"));
				else
					isLineTable.txt[2].txt = tostring(animalGeneral.age).. " ".. tostring(g_i18n:getText("ui_day"));
				end;		
				isLineTable.txt[2].width = 30;
				isLineTable.txt[2].alignment = 3;
				---age---
				---costsPerActiveMonth---
				--lineTable.line[#lineTable.line+1] = {};
				--isLineTable = lineTable.line[#lineTable.line];
				--isLineTable.txt = {};
				--isLineTable.txt[1] = {};
				--isLineTable.txt[1].slotColor = "txt";
				--isLineTable.txt[1].bold = true;
				--isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_maintenance").. "/".. g_i18n:getText("ui_month"));	
				--isLineTable.txt[1].width = 70;
				--isLineTable.txt[2] = {};
				--isLineTable.txt[2].slotColor = "txt";
				--isLineTable.txt[2].bold = true;				
				--isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(animalGeneral.costsPerActiveMonth, 0, true, false));						
				--isLineTable.txt[2].width = 30;
				--isLineTable.txt[2].alignment = 3;				
				---costsPerActiveMonth---
				---seperator---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txtOutputTitle";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = "----";
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txtOutputTitle";
				isLineTable.txt[2].bold = true;
				isLineTable.txt[2].txt = "----";
				isLineTable.txt[2].alignment = 3;				
				---seperator---
			else
				if not isOwned and canBuy then
					local playerFarm = Utils.getNoNil(g_farmManager:getFarmById(playerFarmId), 0);
					canBuy = playerFarm.money >= animalGeneral.price;
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("action_buyProductionPoint"));
					isLineTable.txt[1].slotColor = "txt";
					isLineTable.txt[1].width = 70;
					isLineTable.txt[1].callback = moAnimalsOutput.clickBuyAnimal;
					isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};					
					isLineTable.txt[2] = {};
					isLineTable.txt[2].bold = true;
					isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(animalGeneral.price, 0, true, false));
					if canBuy then
						isLineTable.txt[2].slotColor = "settingOn";
					else
						isLineTable.txt[2].slotColor = "settingOff";
					end;
					isLineTable.txt[2].callback = moAnimalsOutput.clickBuyAnimal;
					isLineTable.txt[2].ownTable = {cmdObject[o].rootNode};
					isLineTable.txt[2].width = 30;
					isLineTable.txt[2].alignment = 3;
					stopInOutput = true;				
				elseif not isOwned and not canBuy then
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_construction_landIsNotOwned")).. " (".. tostring(g_i18n:getText("construction_category_production")).. ")";
					isLineTable.txt[1].slotColor = "settingReady";					
				end;
			end;			
			-------------------------------general-------------------------------
			-----------------------------productivity------------------------------
			if not animalGeneral.isHorse and not stopInOutput then
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(animalGeneral.productivityName);
				local color = animalGeneral.productivityColor;
				if color > 1 then
					isLineTable.txt[1].prozentColor = color;
				else
					isLineTable.txt[1].slotColor = "txt";
				end;
				isLineTable.txt[1].width = 80;
				
				isLineTable.txt[2] = {};			
				isLineTable.txt[2].width = 20;	
				if color > 1 then
					isLineTable.txt[2].prozentColor = color;
				else
					isLineTable.txt[2].slotColor = "txt";
				end;
				isLineTable.txt[2].bold = true;
				if animalGeneral.productivity > 0 then
					isLineTable.txt[2].txt = animalGeneral.productivity.. "%";				
				else
					isLineTable.txt[2].txt = "0%";	
				end;
				isLineTable.txt[2].alignment = 3;
				if g_currentMission.hl.isMouseCursor then
					iconColor = "darkGray";
					buttonName = "buttonDown";
					if viewProductionInfo then iconColor = "green";buttonName = "buttonUp";end;				
					isLineTable.txt[1].icon = {before={},after={},behindTxt={}};
					isLineTable.txt[1].icon.behindTxt[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moAnimalsOutput.clickViewProductionInfo}, ownTable={cmdObject[o].rootNode}, infoTxt="Production Info"};
				end;
			elseif animalGeneral.isHorse then
				viewProductionInfo = true;
			end;
			-----------------------------productivity------------------------------
			-----------------------------output input------------------------------			
			if isOwned then					
				local animalOutput = cmdObject[o].mohTable.output;
				local animalInput = cmdObject[o].mohTable.input;
				local viewOutput = cmdObject[o].mohTable.viewOutput;
				local viewInput = cmdObject[o].mohTable.viewInput;						
				if not stopInOutput and viewProductionInfo then
					---output---
					if #animalOutput > 0 then
						if #animalOutput > 2 then
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];			
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].slotColor = "txt";
							isLineTable.txt[1].bold = true;			
							if not moModule.values.inputOutputInLanguage then
								isLineTable.txt[1].txt = "Out ++ ".. "(".. tostring(#animalOutput).. ")";			
							else
								isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_outgoingProducts")).. " (".. tostring(#animalOutput).. ")";
							end;								
							isLineTable.txt[1].callback = moAnimalsOutput.clickViewInputOutputOnOff;
							isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 1};
							iconColor = "red";
							buttonName = "buttonDown";
							if viewOutput then iconColor = "green";buttonName = "buttonUp";end;
							isLineTable.txt[1].icon = {before={},after={}};
							isLineTable.txt[1].icon.before[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moAnimalsOutput.clickViewInputOutputOnOff}, ownTable={cmdObject[o].rootNode, 1}};
						else
							viewOutput = true;
						end;
						if viewOutput then
							for output=1, #animalOutput do
								if animalOutput[output] ~= nil then
									lineTable.line[#lineTable.line+1] = {};
									isLineTable = lineTable.line[#lineTable.line];
									isLineTable.txt = {};
									isLineTable.txt[1] = {};
									isLineTable.txt[1].slotColor = "txt";
									isLineTable.txt[1].bold = false;
									isLineTable.txt[1].txt = tostring(animalOutput[output].groupName);
									isLineTable.txt[1].width = 60;
									if animalOutput[output].fillTypeNames ~= nil then
										isLineTable.txt[1].callback = moAnimalsOutput.clickOutInGroupName;
										isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 1, tostring(animalOutput[output].groupName), tostring(animalOutput[output].fillTypeNames)};
									end;
									isLineTable.txt[2] = {};
									isLineTable.txt[2].slotColor = "txt";
									isLineTable.txt[2].bold = false;
									isLineTable.txt[2].txt = tostring(animalOutput[output].fillLevel);
									isLineTable.txt[2].callback = moAnimalsOutput.clickFillLevelCapacity;
									isLineTable.txt[2].ownTable = {cmdObject[o].rootNode, tostring(animalGeneral.objectName), tostring(animalOutput[output].groupName), tostring(animalOutput[output].capacity)};
									isLineTable.txt[2].width = 40;
									isLineTable.txt[2].alignment = 3;
								end;
							end;
						end;
					end;
					---output---
					---input---
					if #animalInput > 0 then
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];			
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = true;										
						if not moModule.values.inputOutputInLanguage then
							isLineTable.txt[1].txt = "In ++ ".. "(".. tostring(#animalInput).. ")";				
						else
							isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_incomingMaterials")).. " (".. tostring(#animalInput).. ")";
						end;							
						isLineTable.txt[1].callback = moAnimalsOutput.clickViewInputOutputOnOff;
						isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 2};
						iconColor = "red";
						buttonName = "buttonDown";
						if viewInput then iconColor = "green";buttonName = "buttonUp";end;
						isLineTable.txt[1].icon = {before={},after={}};
						isLineTable.txt[1].icon.before[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moAnimalsOutput.clickViewInputOutputOnOff}, ownTable={cmdObject[o].rootNode, 2}};
						if viewInput then
							for input=1, #animalInput do
								if animalInput[input] ~= nil then
									lineTable.line[#lineTable.line+1] = {};
									isLineTable = lineTable.line[#lineTable.line];
									isLineTable.txt = {};
									isLineTable.txt[1] = {};
									isLineTable.txt[1].slotColor = "txt";
									isLineTable.txt[1].bold = false;
									isLineTable.txt[1].txt = tostring(animalInput[input].groupName);
									isLineTable.txt[1].width = 70;
									if animalInput[input].fillTypeNames ~= nil then
										isLineTable.txt[1].callback = moAnimalsOutput.clickOutInGroupName;
										isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 2, tostring(animalInput[input].groupName), tostring(animalInput[input].fillTypeNames)};
									end;
									isLineTable.txt[2] = {};
									isLineTable.txt[2].slotColor = "txt";
									isLineTable.txt[2].bold = false;
									isLineTable.txt[2].txt = tostring(animalInput[input].fillLevel); --tostring(animalInput[input].percentageCapacity).. "%";
									isLineTable.txt[2].callback = moAnimalsOutput.clickFillLevelCapacity;
									isLineTable.txt[2].ownTable = {cmdObject[o].rootNode, tostring(animalGeneral.objectName), tostring(animalInput[input].groupName), tostring(animalInput[input].capacity)};
									isLineTable.txt[2].width = 30;
									isLineTable.txt[2].alignment = 3;						
								end;
							end;
						end;
					end;
					---input---
				end;				
			end;
			-----------------------------output input------------------------------				
		end;
	end;
	moAnimals[cmdRegName] = {output=lineTable};
end;

function moAnimalsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.object == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="animals" } );
	moAnimalsOutput:load(args.cmdTable, args.slotTable);
	return moAnimals[args.cmdTable.regName].output;
end;

function moAnimalsOutput.clickAnimalHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Animal Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Animal Name/Productivity Name for more Info or MapHotSpot or ...\nClick Mouse Right Optional Titel Animal Name for Teleport(onFoot)";
	end;
end;

function moAnimalsOutput.clickViewMoreInfo(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				object.mohTable.viewMoreInfo = not object.mohTable.viewMoreInfo;
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickBuyAnimal(args)
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				--object.spec_productionPoint.productionPoint:buyRequest();				
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickViewProductionInfo(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				object.mohTable.viewProductionInfo = not object.mohTable.viewProductionInfo;
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickOutInGroupName(args)
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil and args.ownTable[3] ~= nil and args.ownTable[4] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				if args.ownTable[2] == 1 then
					moSetGetOverlays.infoHelpBox.info.titel = "Animal *".. tostring(args.ownTable[3]).. "*";
					moSetGetOverlays.infoHelpBox.info.txt = tostring(args.ownTable[4]);
				else
					moSetGetOverlays.infoHelpBox.info.titel = "Animal ".. tostring(g_i18n:getText("ui_animalFood")).. ": *".. tostring(args.ownTable[3]).. "*";
					moSetGetOverlays.infoHelpBox.info.txt = tostring(args.ownTable[4]);
				end;
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickAnimal(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then				
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				local x, _, z = getWorldTranslation(args.ownTable[1]);						
				if x ~= nil and x ~= 0 then					
					moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1);
				end;
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then				
		if args.ownTable[1] ~= nil and g_currentMission.controlledVehicle == nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil and object.spec_hotspots ~= nil and object.spec_hotspots.mapHotspots ~= nil then
				local hotspot = object.spec_hotspots.mapHotspots[1];
				if hotspot ~= nil and hotspot.teleportWorldX ~= nil and hotspot.teleportWorldY ~= nil and hotspot.teleportWorldZ ~= nil then
					g_currentMission.player:moveToAbsolute(hotspot.teleportWorldX, hotspot.teleportWorldY, hotspot.teleportWorldZ, false, false);
					MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moAnimalsOutput.clickAnimal"); --force mouseOff
				end;				
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickViewInputOutputOnOff(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil then					
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then				
				if args.ownTable[2] == 1 then
					object.mohTable.viewOutput = not object.mohTable.viewOutput;
				elseif args.ownTable[2] == 2 then
					object.mohTable.viewInput = not object.mohTable.viewInput;
				end;
			end;			
		end;
	end;
end;
moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="animals" } );