moFillTypes = {};
source(MultiOverlayV4.modDir.."scripte/module/filltypes/moFillTypesConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/filltypes/moFillTypesOutput.lua");

function moFillTypes:update(dt)
end;

function moFillTypes.loadFillTypes(update) --onStartMission Callback	
	if update == nil or not update then moFillTypesConfig:defaultValues();moFillTypesConfig.generateCmd();moFillTypes:loadTotalFillTypes();end;		
end;

function moFillTypes:loadTotalFillTypes()	
	function isFillAnimals(index)		
		if g_currentMission.fillTypeManager.categoryNameToFillTypes["ANIMAL"][index] ~= nil or g_currentMission.fillTypeManager.categoryNameToFillTypes["HORSE"][index] ~= nil then return true;end;
		return false;
	end;
	function noFillType(descName)
		if not moFillTypes.values.loadNoFillTypes then return false;end;
		for index, name in pairs (moFillTypes.values.noFillType) do
			if string.lower(name) == string.lower(descName) then return true;end;
		end;
		return false;
	end;
	local lineTable = {};
	function getAnmialName(name, descName)
		for key, value in pairs (g_currentMission.animalSystem.types) do			
			local isName = g_currentMission.animalSystem.types[key].name;
			if name == isName then
				local tempName = g_i18n:getText("ui_statisticView_".. string.lower(isName));
				local languageXmlName = moLanguageXml:getTxt(string.lower("fill_"..descName), nil, name);
				if string.find(tempName, "MISSING") then tempName = isName;end;
				if moModule.values.languageXml and not string.find(languageXmlName, "MISSING") then tempName = languageXmlName;end;
				return tempName;
			end;
		end;
		return name;
	end;	
	if g_currentMission.fillTypeManager.fillTypes ~= nil then		
		for index, desc in pairs(g_currentMission.fillTypeManager.fillTypes) do		
			if desc ~= nil and desc.name ~= nil and desc.index ~= nil then		
				lineTable[desc.index] = {};
				isLineTable = lineTable[desc.index];								
				isLineTable.index = desc.index;
				isLineTable.regName = desc.name;
				isLineTable.titleName = desc.title;				
				isLineTable.isAnimal = isFillAnimals(desc.index);
				local name = desc.title;
				if isLineTable.isAnimal then
					name = getAnmialName(name, desc.name);
				else
					local languageXmlName = moLanguageXml:getTxt(string.lower("fill_".. desc.name), nil, name);
					if moModule.values.languageXml and not string.find(languageXmlName, "MISSING") then name = languageXmlName;end;
				end;
				isLineTable.name = tostring(name); --convert Name
				isLineTable.view = not noFillType(desc.name) and not isLineTable.isAnimal;
				isLineTable.pricePerLiter= Utils.getNoNil(desc.pricePerLiter, 0);
				isLineTable.previousHourPrice = Utils.getNoNil(desc.previousHourPrice, 0);
				isLineTable.massPerLiter = Utils.getNoNil(desc.massPerLiter, 0);
				isLineTable.startPricePerLiter = Utils.getNoNil(desc.startPricePerLiter, 0);
				isLineTable.totalAmount = Utils.getNoNil(desc.totalAmount, 0);
				isLineTable.showOnPriceTable = desc.showOnPriceTable;				
				isLineTable.greatDemandReady = false;
				isLineTable.greatDemand = {};
				isLineTable.bestPrice = 0;
				isLineTable.bestPriceStations = "";
				isLineTable.amounts = {};							
			end;			
		end;
	end;	
	moFillTypes.values.fillTypes = lineTable;	
end;

function getMultiplier()
	if g_currentMission.missionDynamicInfo.isMultiplayer then return 1 else return EconomyManager.getPriceMultiplier();end;
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moFillTypes.loadFillTypes } );