moMissionsOutput = {};

function moMissionsOutput:load(slotTable)
	local lineTable = {line={}};
	local isLineTable = nil;	
	if moMissions.values.missions ~= nil then		
		if #moMissions.values.missions > 0 then
			for m=1, #moMissions.values.missions do
				local mission = moMissions.values.missions[m];			
				local color = "txt";
				local moreTxt = "";
				if mission.active then color = "txtExtra";end;
				--if mission.possible then color = "settingOff";end;
				if mission.finished then color = "settingOn";end;
				if mission.active or mission.finished then
					table.insert(lineTable.line, 1, {});				
					isLineTable = lineTable.line[1];
				else
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];				
				end;
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].slotColor = color;
				local money = g_i18n:formatMoney(mission.mission:getReward(), 0, true, true)
				isLineTable.txt[1].txt = tostring(money);
				isLineTable.txt[1].callback = moMissionsOutput.clickMissionsMoney;
				isLineTable.txt[1].ownTable = {mission.missionId};
				isLineTable.txt[1].width = 20;
				
				isLineTable.txt[2] = {};
				isLineTable.txt[2].bold = true;
				isLineTable.txt[2].slotColor = color;			
				local name = mission.jobType;
				local fillFruitName = "Unknown or not defined";
				if mission.isField then 
					if mission.fillType ~= nil then
						if moFillTypes.values.fillTypes[mission.fillType] ~= nil then
							fillFruitName = moFillTypes.values.fillTypes[mission.fillType].name;
							moreTxt = "#".. string.sub(fillFruitName, 1,3):upper();
						end;
					elseif mission.fruitType ~= nil then
						local fruitTypeIndex = g_fruitTypeManager:getFillTypeIndexByFruitTypeIndex(mission.fruitType);
						if moFillTypes.values.fillTypes[fruitTypeIndex] ~= nil then
							fillFruitName = moFillTypes.values.fillTypes[fruitTypeIndex].name;
							moreTxt = "#".. string.sub(fillFruitName, 1,3):upper();
						end;
					end;
					moreTxt = moreTxt.. "(F-".. tostring(mission.fieldId).. ") ".. tostring(string.format("%1.2f", "".. tostring(mission.fieldHectar))).. " ".. tostring(g_i18n:getText("unit_haShort"));
				elseif mission.numObjects ~= nil and mission.numObjects > 0 then
					moreTxt = "(".. tostring(mission.numObjects).. ")";
				end; 
				isLineTable.txt[2].txt = tostring(name).. tostring(moreTxt);
				if mission.isField then				
					isLineTable.txt[2].callback = moMissionsOutput.clickMissionsName;
					isLineTable.txt[2].ownTable = {mission.fieldId};
				end;
				isLineTable.txt[2].alignment = 2;
				isLineTable.txt[2].width = 65;
				
				moreTxt = "";
				isLineTable.txt[3] = {};
				isLineTable.txt[3].bold = true;
				isLineTable.txt[3].slotColor = color;
				if mission.vehicle then moreTxt = "L#";end;
				isLineTable.txt[3].txt = tostring(moreTxt).. tostring(mission.prozent).. "%";			
				if mission.isField then				
					isLineTable.txt[3].callback = moMissionsOutput.clickMissionsProzent;
					isLineTable.txt[3].ownTable = {fillFruitName};
				end;
				isLineTable.txt[3].alignment = 3;
				isLineTable.txt[3].width = 15;
			end;	
		end;		
		
		table.insert(lineTable.line, 1, {});
		isLineTable = lineTable.line[1];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "Map ".. tostring(g_i18n:getText("ui_mapHotspotFilter_contracts")).. "(".. tostring(#moMissions.values.missions).. ")"; 
		isLineTable.txt[1].callback = moMissionsOutput.clickMissionsTotal;
		isLineTable.txt[1].alignment = 2;
		if slotTable ~= nil and slotTable.help.outputOn then
			isLineTable.txt[1].icon = {before={},after={}};
			isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moMissionsOutput.clickMissionsHelpTxt}};
		end;
		if #moMissions.values.missions <= 0 then
			table.insert(lineTable.line, 2, {});
			isLineTable = lineTable.line[2];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txt";
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_noMissions"));
		else 
			table.insert(lineTable.line, 2, {});
			isLineTable = lineTable.line[2];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txtOutputTitle";
			isLineTable.txt[1].bold = true;		
			if moMissions.values.sortBy == 1 then
				isLineTable.txt[1].txt = "Sort by *Price*";
			elseif moMissions.values.sortBy == 2 then
				isLineTable.txt[1].txt = "Sort by *Type*";
			elseif moMissions.values.sortBy == 3 then
				isLineTable.txt[1].txt = "Sort by *Hectar*";
			else
				isLineTable.txt[1].txt = "Sort by *Field*";	
			end;
			isLineTable.txt[1].callback = moMissionsOutput.clickMissionsSortBy;
			isLineTable.txt[1].icon = {before={},after={}};
			isLineTable.txt[1].icon.before[1] = {name="buttonLeft", color="green", settingButton=true, callback={[1]=moMissionsOutput.clickMissionsSortBy}};
		end;
	end;
	moMissionsOutput.output = lineTable;
end;

function moMissionsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="missions" } );
	moMissionsOutput:load(args.slotTable);
	return moMissionsOutput.output;
end;

function moMissionsOutput.clickMissionsSortBy(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if moMissions.values.sortBy+1 > 4 then moMissions.values.sortBy = 1;else moMissions.values.sortBy = moMissions.values.sortBy+1;end;
		moMissions.load(args.slotTable); --refresh
	end;
end;

function moMissionsOutput.clickMissionsHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Map Missions Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Map Missions/Sort By/Mission/Price for more Info or MapHotSpot or ...";
	end;
end;

function moMissionsOutput.clickMissionsTotal(args)	
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if g_currentMission.inGameMenu.pageContracts == nil then return;end;
		g_gui:showGui("InGameMenu");
		local missionPageId = g_currentMission.inGameMenu.pagingElement:getPageIdByElement(g_currentMission.inGameMenu.pageContracts);
		local missionPageIndex = g_currentMission.inGameMenu.pagingElement:getPageMappingIndex(missionPageId);
		g_currentMission.inGameMenu.pageSelector:setState(missionPageIndex, true);
	end;
end;

function moMissionsOutput.clickMissionsProzent(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if args.ownTable[1] ~= nil then
			g_currentMission:showBlinkingWarning("Mission Fill/FruitType: ".. tostring(args.ownTable[1]), 2000);
		end;
	end;
end;

function moMissionsOutput.clickMissionsName(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if args.ownTable[1] ~= nil and args.ownTable[1] > 0 then
			local field = g_fieldManager.fields[args.ownTable[1]];
			if field ~= nil then
				local x, z = field:getCenterOfFieldWorldPosition();
				if x ~= nil and x ~= 0 then
					moSetGetOverlays:mapHotSpot({"Field"}, {x}, {z}, 1);
				end;
			end;
		end;
	end;
end;		

function moMissionsOutput.clickMissionsMoney(args)	
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if g_currentMission.inGameMenu.pageContracts == nil then return;end;
		local missionId = args.ownTable[1];
		if missionId > 0 then
			g_gui:showGui("InGameMenu");
			local missionPageId = g_currentMission.inGameMenu.pagingElement:getPageIdByElement(g_currentMission.inGameMenu.pageContracts);
			local missionPageIndex = g_currentMission.inGameMenu.pagingElement:getPageMappingIndex(missionPageId);
			g_currentMission.inGameMenu.pageSelector:setState(missionPageIndex, true);						
			local section, index = g_currentMission.inGameMenu.pageContracts.contractsList:getSelectedPath()
			local sectionContracts = g_currentMission.inGameMenu.pageContracts.sectionContracts[section]
			
			if sectionContracts.contracts[index].mission.id ~= missionId then
				for s=1, #g_currentMission.inGameMenu.pageContracts.sectionContracts do
					for i=1, #g_currentMission.inGameMenu.pageContracts.sectionContracts[s].contracts do
						if g_currentMission.inGameMenu.pageContracts.sectionContracts[s].contracts[i].mission.id == missionId then
							g_currentMission.inGameMenu.pageContracts.contractsList.selectedSectionIndex = s;
							g_currentMission.inGameMenu.pageContracts.contractsList.selectedIndex = i;
							g_currentMission.inGameMenu.pageContracts:updateList();							
							return;
						end;
					end;
				end;
			end;			
		end;
	end;	
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="missions" } );